#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<malloc.h>
#include<math.h>

void le_mode(int);
#pragma aux le_mode = "int 10h" parm[eax];

char *resultat;

int Largeur;
int Hauteur;

#define ON 1
#define OFF 0

struct s_cpc_pal
       {
       int r,v,b;
       };

struct s_cpc_pal cpc_pal[27];

char used_color[27];


void *rmalloc(int len)
{
void *ptr;

ptr=(void*)malloc(len);

if (!ptr)
   {
   le_mode(3);
   printf("malloc error!\n");
   exit(2);
   }

return(ptr);
}


unsigned char * convertion_raw8bits_to_raw24bits(unsigned char *buffer8bits)
{
unsigned char *buffer24bits;
int cpal[768];
int i;

int c;

printf("256 colors file\n");

buffer24bits=(unsigned char*)rmalloc(Largeur*Hauteur*3+1024);

for (i=0;i<768;i++)
    cpal[i]=buffer8bits[i];

for (i=0;i<Largeur*Hauteur;i++)
    {
    c=buffer8bits[i+768];

    buffer24bits[i*3]=cpal[c*3];
    buffer24bits[i*3+1]=cpal[c*3+1];
    buffer24bits[i*3+2]=cpal[c*3+2];
    }

return(buffer24bits);
}

unsigned char* lis_fichier_raw(char *le_nom)
{
unsigned char header[32];
int taille;
FILE *f;
char *buffer;
char *buffer2;

f=fopen(le_nom,"rb");
fread(header,32,1,f);

if (header[0]=='m')
if (header[1]=='h')
if (header[2]=='w')
if (header[3]=='a')
if (header[4]=='n')
if (header[5]=='h')
   {
   Largeur=((int)header[8]*256)+(int)header[9];
   Hauteur=((int)header[10]*256)+(int)header[11];

   printf("RAW file detected\n\n");
   printf("* %dx%d ",Largeur,Hauteur);

   if (header[12]==1)
      {
      buffer2=rmalloc(Largeur*Hauteur+768+1+1024);
      fread(buffer2,Largeur*Hauteur+768,1,f);
      fclose(f);
      buffer=convertion_raw8bits_to_raw24bits(buffer2);
      free(buffer2);
      }
   else
   if (header[12]==0)
      {
      buffer=rmalloc(Largeur*Hauteur*3+768+1+1024);
      printf("true colors file\n");
      fread(buffer,Largeur*Hauteur*3,1,f);
      fclose(f);
      }
   else
      {
      printf("\n\nRAW format not supported! (try 8bits or 24bits file)\n");
      return NULL;
      }

   return(buffer);
   }

return NULL;
}


struct s_couleur_chaine
        {
        struct s_couleur_chaine *prec;        
        int r,v,b;
        int nb_oc;
        struct s_couleur_chaine *suiv;        
        };

struct s_couleur_chaine *tete=NULL;

int cherche_couleur(int r,int v,int b)
{
struct s_couleur_chaine *cur;
int ret=OFF;

cur=tete;

while (cur!=NULL)
      {
      if (r==cur->r)
      if (v==cur->v)
      if (b==cur->b)
         {
         cur->nb_oc++;
         ret=ON;
         break;
         }

      cur=cur->suiv;
      }

return(ret);
}

void nouvelle_couleur(int r,int v,int b)
{
struct s_couleur_chaine *cur;
struct s_couleur_chaine *nouvelle;

nouvelle=rmalloc(sizeof(struct s_couleur_chaine));
memset(nouvelle,0,sizeof(struct s_couleur_chaine));

if (tete==NULL)
   cur=tete=nouvelle;
else
   cur=tete;

while (cur!=NULL)
      {
      if (cur->suiv==NULL)
         {
         cur->suiv=nouvelle;

         nouvelle->r=r;
         nouvelle->v=v;
         nouvelle->b=b;

         nouvelle->nb_oc=1;

         nouvelle->prec=cur;
         nouvelle->suiv=NULL;
         break;
         }

      cur=cur->suiv;
      }

}

int compte_couleur(unsigned char *buffer)
{
int count;
int i;

count=0;

for (i=0;i<Largeur*Hauteur*3;i+=3)
    {
    if (!cherche_couleur(buffer[i],buffer[i+1],buffer[i+2]))
       {
       count++;
       printf("* computing colors (%d)\r",count);
       fflush(stdout);

       nouvelle_couleur(buffer[i],buffer[i+1],buffer[i+2]);
       }
    }

printf("\n");
return(count);
}

/****************************************************************************

             R O U T I N E S   D E    C O N V E R S I O N

****************************************************************************/

enum e_convert_mode
{
RAW,
DISTANCE,
DISTANCE16
};

static char *modou[]={"RAW","DISTANCE","DISTANCE 16",NULL};

void mode0convert(char *buffer)
{
int x,y,i,r,v,b,c,sortir,mode=DISTANCE16;
char com;

int dist,rdist,max,ind,bouky,dekx=0;

float cr,cv,cb;
float rpal[27*3];

int pal[27];

int manage_ecran,scrollX,scrollY;

le_mode(19);
outp(0x3C8,0);
for (i=0;i<27;i++)
    {
    outp(0x3C9,cpc_pal[i].r);
    outp(0x3C9,cpc_pal[i].v);
    outp(0x3C9,cpc_pal[i].b);
    }

for (i=0;i<27;i++)
    {
    rpal[i*3]=cpc_pal[i].r*cpc_pal[i].r;
    rpal[i*3+1]=cpc_pal[i].v*cpc_pal[i].v;
    rpal[i*3+2]=cpc_pal[i].b*cpc_pal[i].b;
    }

resultat=rmalloc(Largeur*Hauteur);

cr=8.0;
cv=8.0;
cb=8.0;

sortir=0;
scrollY=0;

while (!sortir)
      {
      memset(used_color,0,27);
      memset(pal,0,27*4);

      printf("calculating...                         \r");
      fflush(stdout);

      for (y=0;y<Hauteur;y++)
          {
          for (x=0;x<Largeur;x+=2)
              {
              r=buffer[y*Largeur*3+x*3];    r+=buffer[y*Largeur*3+x*3+3];
              v=buffer[y*Largeur*3+x*3+1];  v+=buffer[y*Largeur*3+x*3+4];
              b=buffer[y*Largeur*3+x*3+2];  b+=buffer[y*Largeur*3+x*3+5];

              r/=cr;        v/=cv;        b/=cb;

              if (mode==RAW)
                 {
                 i=0;
                 if (b<16) i+=0; else if (b<48) i+=1; else i+=2;
                 if (v<16) i+=0; else if (v<48) i+=3; else i+=6;
                 if (r<16) i+=0; else if (r<48) i+=9; else i+=18;
                 }
              else
              if (mode==DISTANCE)
                 {
                 i=0;
                 rdist=65536*64;

                 for (c=0;c<27;c++)
                     {
                     dist=abs(cpc_pal[c].r-r)+abs(cpc_pal[c].v-v)+abs(cpc_pal[c].b-b);
                     if (dist<rdist)
                        {
                        rdist=dist;
                        i=c;
                        }
                     }
                 }
              else
              if (mode==DISTANCE16)
                 {
                 i=0;
                 rdist=65536*64;

                 for (c=0;c<27;c++)
                     {
                     dist=abs(cpc_pal[c].r-r)+abs(cpc_pal[c].v-v)+abs(cpc_pal[c].b-b);
                     if (dist<rdist)
                        {
                        rdist=dist;
                        i=c;
                        }
                     }
                 pal[i]++;
                 }

              resultat[x+y*Largeur]=i;
              resultat[x+y*Largeur+1]=i;
              used_color[i]=1;
              }
          }

      if (mode==DISTANCE16)
         {
         printf("replacing colors (16max)\r");
         fflush(stdout);

         memset(used_color,0,27);

         /* on chope les couleurs les plus utilisees */

         for (x=0;x<16;x++)
             {
             max=-1;ind=-1;
             for (c=0;c<27;c++)
                 {
                 if (!used_color[c])
                    {
                    if (pal[c]>max)
                       {
                       max=pal[c];
                       ind=c;
                       }
                    }
                 }
             used_color[ind]=1;
             }

         for (c=0;c<27;c++)
             {
             if (!used_color[c])
                {
                i=0;
                rdist=65536*64;
                for (x=0;x<27;x++)
                    {
                    if (used_color[x])
                       {
                       dist=abs(cpc_pal[x].r-cpc_pal[c].r)+abs(cpc_pal[x].v-cpc_pal[c].v)+abs(cpc_pal[x].b-cpc_pal[c].b);
                       if (dist<rdist)
                          {
                          rdist=dist;
                          i=x;
                          }
                       }
                    }

                for (x=0;x<Largeur*Hauteur;x++)
                    if (resultat[x]==c)
                       resultat[x]=i;
                }
             }
         }


      bouky=Hauteur-scrollY;
      if (bouky>320) bouky=320;
      for (i=0;i<bouky;i++)
          memcpy(0xA0000+320*i,resultat+scrollY*Largeur+i*Largeur,320);

      c=0;
      for (i=0;i<27;i++)
          if (used_color[i])
             c++;

      printf("%s (%d)\r",modou[mode],c);
      fflush(stdout);

      manage_ecran=ON;
      while (manage_ecran)
            {
            while (!kbhit());
            com=getch();

            if (com=='w')
               {
               if (scrollY<Hauteur-200)
               scrollY++;
               }
            else
            if (com=='q')
               {
               if (scrollY>0)
                  scrollY--;
               }
            else
            if (com=='x')
               {
               if (dekx>0)
                  dekx--;
               }
            else
            if (com=='c')
               {
               if (dekx<Largeur-320)
                  dekx++;
               }
            else
               manage_ecran=OFF;

      bouky=Hauteur-scrollY;
      if (bouky>320) bouky=320;
      for (i=0;i<bouky;i++)
          memcpy(0xA0000+320*i,resultat+scrollY*Largeur+i*Largeur,320);
            }


      if (com==' ')
         sortir++;
      else
      if (com=='7')
         cr-=0.3;
      else
      if (com=='4')
         cr+=0.3;
      else
      if (com=='8')
         cv-=0.3;
      else
      if (com=='5')
         cv+=0.3;
      else
      if (com=='9')
         cb-=0.3;
      else
      if (com=='6')
         cb+=0.3;
      else
      if (com=='+')
         {
         cr-=0.3;
         cv-=0.3;
         cb-=0.3;
         }
      else
      if (com=='-')
         {
         cr+=0.3;
         cv+=0.3;
         cb+=0.3;
         }
      else
      if (com=='r')
         {
         cr+=8.0;
         cv+=8.0;
         cb+=8.0;
         }
      else
      if (com=='m')
         {
         if (mode==RAW)
            mode=DISTANCE;
         else
         if (mode==DISTANCE)
            mode=DISTANCE16;
         else
         if (mode==DISTANCE16)
            mode=RAW;
         }
      else
      if (com=='h')
         {
         le_mode(3);

         printf("Simone (c)   by Flower Corp. (inc)   Convertissure (tm)\n\n");
         printf("\n");
         printf("(+/-) modify gamma\n");
         printf("(7/4) modify red\n");
         printf("(8/5) modify green\n");
         printf("(9/6) modify blue\n");
         printf("\n");
         printf("(r)   reset to default\n");
         printf("\n");
         printf("<space> quit module\n");

         printf("\n");
         switch (mode)
                {
                case RAW:printf("RAW conversion\n");break;
                case DISTANCE:printf("DISTANCE conversion\n");break;
                case DISTANCE16:printf("DISTANCE 16 conversion\n");break;
                default:printf("Unknown conversion\n");break;
                }


         while (!kbhit());
         getch();
         le_mode(19);
         outp(0x3C8,0);
         for (i=0;i<27;i++)
             {
             outp(0x3C9,cpc_pal[i].r);
             outp(0x3C9,cpc_pal[i].v);
             outp(0x3C9,cpc_pal[i].b);
             }
         }

      }
}



/****************************************************************************

                          M       A      I       N

****************************************************************************/

char cpcfile[65536];

void main(int argc, char **argv)
{
FILE *f;
char *buffer;
int c,i,coulors,r,v,b,x,y,ad,cpcfile_ptr;
int old,lec,wri,mode;
char output_file_name[256],a;
int sortir=0;

int indir[27];

if (argc<2)
   {
   printf("Simone (c)   by Flower Corp. (inc)   Convertissure (tm)\n\n");
   printf("\n");
   printf("options are: -+ CPC+ palette\n");
   printf("             -1 convert to mode 1\n");
   printf("             -r use rasters\n");
   printf("             -s use split-rasters\n");
   exit(0);
   }

lec=0;old=1;wri=0;mode=0;
for (i=1;i<argc;i++)
    {
    if (argv[i][0]=='-' || argv[i][0]=='/')
       {
       if (argv[i][1]=='+')
          old=0;
       else
       if (argv[i][1]=='1')
          mode=1;
       else
          {
          printf("unknown option! [%s]\n",argv[i]);
          exit(1);
          }
       }
    else
    if (!lec)
       {
       buffer=lis_fichier_raw(argv[i]);
       if (buffer==NULL)
          {
          printf("input file not found!\n");
          exit(1);
          }
       lec=1;
       }
    else
    if (!wri)
       {
       strcpy(output_file_name,argv[i]);
       wri=1;
       }
    else
       {
       printf("extra argument! [%s]\n",argv[i]);
       exit(1);
       }

   }

//coulors=compte_couleur(buffer);

if (old)
   {
   printf("* CPC old generation colors (27 max)\n");
   }
else
   {
   printf("* CPC new generation colors (4096 max) not implemented!\n");
   exit(0);
   }

i=0;
for (v=0;v<3;v++)
    for (r=0;r<3;r++)
        for (b=0;b<3;b++)
            {
            cpc_pal[i].r=r*32;
            cpc_pal[i].v=v*32;
            cpc_pal[i].b=b*32;
            if (cpc_pal[i].r>63)
               cpc_pal[i].r=63;
            if (cpc_pal[i].v>63)
               cpc_pal[i].v=63;
            if (cpc_pal[i].b>63)
               cpc_pal[i].b=63;
            i++;
            }


if (mode==0)
   {
   printf("* converting to mode 0\n");
   mode0convert(buffer);
   }
else
if (mode==1)
   {
   printf("mode 1 not implemented!\n");
   exit(0);
   }
else
   {
   printf("unknown mode!\n");
   exit(1);
   }


/*
vesa_init();
vesa_set_mode(800,600,24);
*/
while (!kbhit());
getch();

le_mode(3);

printf("save to file ? (y/n)\n");
while (!sortir)
      {
      while (!kbhit());
      a=getch();

      if (a=='y' || a=='Y')
         {
         i=0;
         for (c=0;c<27;c++)
             {
             if (used_color[c])
                {
                indir[c]=i;
                printf("indir[%d]=%d\n",c,i);
                i++;
                }
             }

cpcfile_ptr=0;

         for (y=0;y<Hauteur;y++)
             {
             ad=0x800*(y&7);
             ad=ad+Largeur/4*(y/8);


             for (x=0;x<Largeur/4;x++)
                 {
                 cpcfile[cpcfile_ptr]=0;

                 c=indir[resultat[x*4+y*Largeur]];

                 if (c&1)
                    cpcfile[cpcfile_ptr]|=128;
                 if (c&2)
                    cpcfile[cpcfile_ptr]|=8;
                 if (c&4)
                    cpcfile[cpcfile_ptr]|=32;
                 if (c&8)
                    cpcfile[cpcfile_ptr]|=2;

                 c=indir[resultat[x*4+y*Largeur+2]];

                 if (c&1)
                    cpcfile[cpcfile_ptr]|=64;
                 if (c&2)
                    cpcfile[cpcfile_ptr]|=4;
                 if (c&4)
                    cpcfile[cpcfile_ptr]|=16;
                 if (c&8)
                    cpcfile[cpcfile_ptr]|=1;

                 cpcfile_ptr++;
                 }
             }
         printf("conversion finished\n");

         f=fopen("output.cpc","wb");

         fwrite(cpcfile,cpcfile_ptr,1,f);

         fclose(f);
         printf("file writed\n");

         for (i=0;i<27;i++)
             if (used_color[i])
                printf("%d ",i);
         printf("\n");
         sortir=1;
         }
      else
      if (a=='n' || a=='N')
         {
         break;
         }
      }
}







